class AopObject extends GroovyObjectSupport implements GroovyInterceptable{

	def after = new HashMap()
	def before = new HashMap()
	
	
	
  public Object invokeMethod(String name,Object args){
	  
		def callDetails = new AopDetails(methodName:name,args:args,called:this)
		
		if(before[name]!=null)
			before[name](callDetails)
			
		def result = super.invokeMethod(name,args)
		
		if(after[name]!=null)
			after[name](callDetails)
			
		return result
	  
  }

}