class AopObject extends GroovyObjectSupport implements GroovyInterceptable {

	def after = new HashMap()
	def before = new HashMap()
	def around = new HashMap()

	
  public Object invokeMethod(String name,Object args){
		def result = null
		def callDetails = new AopDetails(methodName:name,args:args,called:this)
		
		if(before[name]!=null)
			before[name](callDetails)
		
		def continueWith = {super.invokeMethod(name,args)}
				
		callDetails.proceed = { continueWith()  }
		
		if(around[name]!=null)
			result = around[name](callDetails)
		else 
			result = continueWith()
		
		callDetails.proceed = null
		
		if(after[name]!=null)
			after[name](callDetails)
			
		return result  
  }
}