class Runner {

  static void main(args) {
    def controller = new MyWebController()
    def session = [user:5]
    def request = [id:10,email:"john.doe@company.com",user:20,session:session]
    
    println "Attempting initial save : no AOP security:-"
    controller.save(request)
 
    controller.around["save"] = { details |
    	
    	def result = null
    	def req = details.args[0]
    	def reqSession = req["session"]
    	if(reqSession.user==req.user){
    		result = details.proceed()
    	}
    	else{
    		println "Sorry you do not have permission to save this model (${details.called.modelBean.id})"
    	}
    }
    println "\n\nAttempting  save with AOP security & incorrect id:-"
    controller.save(request)
    session["user"]=20
    println "\n\nAttempting  save with AOP security & correct id:-"
    controller.save(request)
  }

}