



class AopObject extends AopIntroductions {

	def after = new HashMap()
	def before = new HashMap()
	def around = new HashMap()
	
	
	
  private Object callInvokeSuper(String name,Object args){
		super.invokeMethod(name,args)
	}
  public Object invokeMethod(String name,Object args){
	  
	
		Object result = null
		def callDetails = new AopDetails(methodName:name,args:args,called:this)
		
		if(before.containsKey(name))
			before[name](callDetails)
			
		
		
		def continueWith = {callInvokeSuper(name,args)}
		
		
		callDetails.proceed = { continueWith()  }
		
		if(around.containsKey(name))
			result = around[name](callDetails)
		else 
			result = continueWith()
		
		callDetails.proceed = null
		
		
		if(after.containsKey(name))
			after[name](callDetails)
			
		return result
	  
  }

}