class CrudOperationMixins {
 
  def host
  def mixins = [view:this.&view,edit:this.&edit,list:this.&list,delete:this.&delete,save:this.&save]
                
  public CrudOperationMixins(host){
	  this.host  = host
	 mixins.each{key,val | host.extend[key] = val }
  }
 
  public view(){
	println "view operation"  
  }
  
  public edit(){
	  println "edit operation"  
  }
  
  public save(request){
	  println "save operation"  
	  def modelBean = host.modelBean
	  modelBean.params(request)
	  modelBean.save()
  }
    
  public delete(){
	  println "delete operation"  
  }
  
  public list(){
	  println "list operation"  
  }

}